Index: trunk/SophyaLib/TArray/spesqmtx.cc
===================================================================
--- trunk/SophyaLib/TArray/spesqmtx.cc	(revision 3809)
+++ trunk/SophyaLib/TArray/spesqmtx.cc	(revision 3809)
@@ -0,0 +1,316 @@
+// --- Special Square matrices base class 
+// This code is part of the SOPHYA library
+//  (C) Univ. Paris-Sud   (C) LAL-IN2P3/CNRS   (C) IRFU-CEA
+//  (C) R. Ansari, C.Magneville    2009  
+
+#include "spesqmtx.h"
+#include "pexceptions.h"
+#include "tmatrix.h"
+
+// doit etre mis en dehors du namespace
+/*!
+  \class SOPHYA::SpecialSquareMatrix
+  \ingroup TArray
+  \brief The base class for representing and manipulating special square matrices
+  Diagonal matrix, Symmetric matrix, Triangular matrix
+
+  This class implements the common operations for special square matrices. Only objects 
+  from the sub-classes (DiagonalMatrix<T>, LowerTriangularMatrix<T>, SymmetricMatrix<T>) 
+  can be instanciated. Theses classes offer similar functionalities to the TArray<T> / TMatrix<T> 
+  classes, like reference sharing and arithmetic operations. However, no sub-matrix extraction 
+  method is provided. 
+  sub matrix extraction method.
+*/
+
+namespace SOPHYA {
+
+//! Default constructor - SpecialSquareMatrix of size 0, SetSize() should be called before the object is used
+template <class T>
+SpecialSquareMatrix<T>::SpecialSquareMatrix(SpSqMtxType typ)
+  : mType(typ) , mNrows(0) , mInfo(NULL) 
+{
+}
+
+//! Instanciate a  SpecialSquareMatrix matrix from the number of rows (rowSize must be > 0)
+template <class T>
+SpecialSquareMatrix<T>::SpecialSquareMatrix(sa_size_t rowSize, SpSqMtxType typ)
+  : mType(typ) , mNrows(rowSize) , mInfo(NULL)
+{
+  if (rowSize < 1) 
+    throw ParmError("SpecialSquareMatrix<T>::SpecialSquareMatrix(rsz) rsz <= 0");
+}
+
+//! Copy constructor (possibility of sharing datas)
+template <class T>
+SpecialSquareMatrix<T>::SpecialSquareMatrix(SpecialSquareMatrix<T> const & a,  bool share)  
+  : mType(a.mType) , mNrows(a.mNrows) , mElems(a.mElems, share)  , mInfo(NULL)
+{
+  if (a.mInfo)  mInfo = new DVList(*(a.mInfo)); 
+}
+
+//! Sets or change the matrix size, specifying the new number of rows
+template <class T>
+void SpecialSquareMatrix<T>::SetSize(sa_size_t rowSize)
+{
+  throw  ForbiddenError("SpecialSquareMatrix<T>::SetSize() Only sub-classes should be instanciated");
+}
+
+//! Return the object  as a standard (TMatrix<T>) object
+template <class T>
+TMatrix<T> SpecialSquareMatrix<T>::ConvertToStdMatrix() const
+{
+  throw  ForbiddenError("SpecialSquareMatrix<T>::ConvertToStdMatrix() Only sub-classes should be instanciated");
+}
+
+
+
+
+//! Clone (duplicate) the SpecialSquareMatrix<T>  matrix \b a
+template <class T>
+void SpecialSquareMatrix<T>::Clone(SpecialSquareMatrix<T> const & a)
+{
+  if ((mType != C_UndefinedMatrix) && (a.mType != mType)) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::Clone()- Different type matrices");
+  mType = a.mType;
+  mNrows = a.mNrows;
+  mElems.Clone(a.mElems);
+  if (a.mInfo)  mInfo = new DVList(*(a.mInfo)); 
+}
+
+//! Share the data with \b a 
+template <class T>
+void SpecialSquareMatrix<T>::Share(SpecialSquareMatrix<T> const & a)
+{
+  if ((mType != C_UndefinedMatrix) && (a.mType != mType)) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::Share()- Different type matrices");
+  mType = a.mType;
+  mNrows= a.mNrows; 
+  mElems.Share(a.mElems);
+  if (a.mInfo)  mInfo = new DVList(*(a.mInfo)); 
+}
+
+//! Clone or share the data. Data is shared if \b is flagged as temporary
+template <class T>
+void SpecialSquareMatrix<T>::CloneOrShare(SpecialSquareMatrix<T> const & a)
+{
+  if ((mType != C_UndefinedMatrix) && (a.mType != mType)) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::CloneOrShare()- Different type matrices");
+  mType = a.mType;
+  mNrows = a.mNrows;
+  mElems.CloneOrShare(a.mElems);
+  if (a.mInfo)  mInfo = new DVList(*(a.mInfo)); 
+}
+
+
+
+//! Set all matrix elements to the value \b a
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::SetCst(T a)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::SetCst(T )- (this) not allocated !");
+  mElems = a;
+  return (*this);
+}
+
+
+//! Element by element copy method 
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::Set(SpecialSquareMatrix<T> const & a)
+{
+  if (a.mType != mType) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::Set(a)- Different type matrices");
+  if (a.mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::Set(a)- Object a not allocated !");  
+  if (mElems.Size() < 1) {
+    mNrows = a.mNrows;
+    mElems.CloneOrShare(a.mElems);
+    return (*this);
+  }
+  if (mNrows != a.mNrows)  
+    throw SzMismatchError("SpecialSquareMatrix<T>::Set(a)- NRows() != a.NRows() ! ");
+  mElems = a.mElems;
+  return (*this);
+}
+
+//! Set the matrix elements using the values from the sequence \b seq
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::SetSeq(Sequence const & seq)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::SetSeq()- (this) not allocated !");
+  for(size_t k=0; k<mElems.Size(); k++)  seq(k).Convert(mElems(k));
+  return (*this);
+}
+
+//! Add a constant value (\b b ) to all matrix elements 
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::AddCst(T b)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::AddCst(T )- (this) not allocated !");
+  mElems += b;
+  return (*this);
+}
+
+//! Subtract a constant value (\b b ) from all matrix elements. fginv==true -> elem = b-elem
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::SubCst(T b, bool fginv)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::Subst(T )- (this) not allocated !");
+  if (fginv) 
+    mElems = mElems.Sub(b, true);
+  else   mElems -= b;
+  return (*this);
+}
+
+//! Multiply all matrix elements by a constant value \b b . 
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::MulCst(T b)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::MulCst(T )- (this) not allocated !");
+  mElems *= b; 
+  return (*this);
+}
+
+//! Divide all matrix elements by a constant value \b b . if fginv==true elem = b / elem 
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::DivCst(T b, bool fginv)
+{
+  if (mElems.Size() < 1)
+    throw SzMismatchError("SpecialSquareMatrix<T>::DivCst(T )- (this) not allocated !");
+  if (fginv)  mElems = mElems.Div(b, true);
+  else mElems /= b;
+  return (*this);
+}
+
+//! Element by element addition : elem(l,m) = elem(l,m) + b.elem(l,m)
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::AddElt(SpecialSquareMatrix<T> const& b)
+{
+  if (b.mType != mType) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::AddElt() Different type matrices");
+  if ((mNrows < 1)||(mNrows != b.mNrows)||(mElems.Size() < 1)||(mElems.Size() != b.mElems.Size()))
+    throw SzMismatchError("SpecialSquareMatrix<T>::AddElt()- Not allocated or different sizes !");
+  mElems += b.mElems;
+  return (*this);
+}
+
+//! Element by element subtraction : elem(l,m) = elem(l,m) - b.elem(l,m)
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::SubElt(SpecialSquareMatrix<T> const& b)
+{
+  if (b.mType != mType) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::SubElt() Different type matrices");
+  if ((mNrows < 1)||(mNrows != b.mNrows)||(mElems.Size() < 1)||(mElems.Size() != b.mElems.Size()))
+    throw SzMismatchError("SpecialSquareMatrix<T>::SubElt()- Not allocated or different sizes !");
+  mElems -= b.mElems;
+  return (*this);
+}
+//! Element by element multiplication : elem(l,m) = elem(l,m) * b.elem(l,m)
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::MulElt(SpecialSquareMatrix<T> const& b)
+{
+  if (b.mType != mType) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::MulElt() Different type matrices");
+  if ((mNrows < 1)||(mNrows != b.mNrows)||(mElems.Size() < 1)||(mElems.Size() != b.mElems.Size()))
+    throw SzMismatchError("SpecialSquareMatrix<T>::MulElt()- Not allocated or different sizes !");
+  mElems *= b.mElems;
+  return (*this);
+}
+//! Element by element divison : elem(l,m) = elem(l,m) / b.elem(l,m)
+template <class T>
+SpecialSquareMatrix<T>& SpecialSquareMatrix<T>::DivElt(SpecialSquareMatrix<T> const& b)
+{
+  if (b.mType != mType) 
+    throw TypeMismatchExc("SpecialSquareMatrix<T>::DivElt() Different type matrices");
+  if ((mNrows < 1)||(mNrows != b.mNrows)||(mElems.Size() < 1)||(mElems.Size() != b.mElems.Size()))
+    throw SzMismatchError("SpecialSquareMatrix<T>::DivElt()- Not allocated or different sizes !");
+  mElems /= b.mElems;
+  return (*this);
+}
+
+
+//! Return the minimum and the maximum values of the SpecialSquare Matrix elements 
+/*!
+  This method generates an exception (\c MathExc) if called for complex matrices
+*/
+template <class T>
+void SpecialSquareMatrix<T>::MinMax(T& min, T& max) const 
+{
+  const T * pe = mElems.Begin();
+  min = pe[0];
+  max = pe[0];
+  for(size_t k=0; k<mElems.Size(); k++) {
+    if (pe[k]<min)  min = pe[k];
+    else if (pe[k]>max)  max = pe[k];      
+  }
+  return;
+}
+
+DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
+void SpecialSquareMatrix< complex<r_4> >::MinMax(complex<r_4>& min, complex<r_4>& max) const
+{
+  throw MathExc("SpecialSquareMatrix< complex<r_4> >::MinMax(...) - No order in complex");
+}
+DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
+void SpecialSquareMatrix< complex<r_8> >::MinMax(complex<r_8>& min, complex<r_8>& max) const
+{
+  throw MathExc("SpecialSquareMatrix< complex<r_4> >::MinMax(...) - No order in complex");
+}
+
+//! Short ASCII representatio of the object pushed to stream \b os 
+template <class T>
+ostream& SpecialSquareMatrix<T>::Show(ostream& os) const
+{
+  os << typeid(*this).name() << " < " << typeid(T).name() 
+     << " > NRow=" << mNrows << " NbElem<>0 : " << Size() << endl;
+  return os;
+}
+
+
+}   // namespace SOPHYA
+
+///////////////////////////////////////////////////////////////
+#ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template SpecialSquareMatrix<uint_1>
+#pragma define_template SpecialSquareMatrix<uint_2>
+#pragma define_template SpecialSquareMatrix<uint_4>
+#pragma define_template SpecialSquareMatrix<uint_8>
+#pragma define_template SpecialSquareMatrix<int_1>
+#pragma define_template SpecialSquareMatrix<int_2>
+#pragma define_template SpecialSquareMatrix<int_4>
+#pragma define_template SpecialSquareMatrix<int_8>
+#pragma define_template SpecialSquareMatrix<r_4>
+#pragma define_template SpecialSquareMatrix<r_8>
+#pragma define_template SpecialSquareMatrix< complex<r_4> > 
+#pragma define_template SpecialSquareMatrix< complex<r_8> > 
+#ifdef SO_LDBLE128
+#pragma define_template SpecialSquareMatrix<r_16>
+#pragma define_template SpecialSquareMatrix< complex<r_16> > 
+#endif
+#endif
+
+#if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
+template class SpecialSquareMatrix<uint_1>;
+template class SpecialSquareMatrix<uint_2>;
+template class SpecialSquareMatrix<uint_4>;
+template class SpecialSquareMatrix<uint_8>;
+template class SpecialSquareMatrix<int_1>;
+template class SpecialSquareMatrix<int_2>;
+template class SpecialSquareMatrix<int_4>;
+template class SpecialSquareMatrix<int_8>;
+template class SpecialSquareMatrix<r_4>;
+template class SpecialSquareMatrix<r_8>;
+template class SpecialSquareMatrix< complex<r_4> >;
+template class SpecialSquareMatrix< complex<r_8> >;
+#ifdef SO_LDBLE128
+template class SpecialSquareMatrix<r_16>;
+template class SpecialSquareMatrix< complex<r_16> >;
+#endif
+}
+#endif
+
Index: trunk/SophyaLib/TArray/spesqmtx.h
===================================================================
--- trunk/SophyaLib/TArray/spesqmtx.h	(revision 3809)
+++ trunk/SophyaLib/TArray/spesqmtx.h	(revision 3809)
@@ -0,0 +1,268 @@
+// This may look like C code, but it is really -*- C++ -*-
+// This code is part of the SOPHYA library
+//  (C) Univ. Paris-Sud   (C) LAL-IN2P3/CNRS   (C) IRFU-CEA
+//  (C) R. Ansari, C.Magneville    2009  
+
+#ifndef SPESQMTX_H_SEEN
+#define SPESQMTX_H_SEEN
+
+#include "ndatablock.h"
+#include "pexceptions.h"
+#include "utilarr.h"
+#include "tmatrix.h"
+
+
+namespace SOPHYA {
+
+//--- enum definissant le type de matrice carre 
+//! enum definition for the differents special square matrix types (or flavours)
+enum SpSqMtxType {
+  C_UndefinedMatrix = 0,        //!< Base type 
+  C_DiagonalMatrix = 1,         //!< Diagonal Matrix 
+  C_SymmetricMatrix = 4,        //!< Symmetric Matrix
+  C_LowerTriangularMatrix = 8,  //!< Lower Triangular Matrix
+  C_UpperTriangularMatrix = 9   //!< Upper Triangular Matrix
+};
+
+//-- forward declaration for the PPF handler 
+template <class T> class FIO_SpecialSquareMatrix;
+  
+template <class T>
+class SpecialSquareMatrix : public AnyDataObj {
+public :
+
+
+// Constructor - size 0, SetSize() should be called before the object is used
+explicit SpecialSquareMatrix(SpSqMtxType typ=C_UndefinedMatrix);
+
+// Constructeur avec specification du nombre de lignes 
+explicit SpecialSquareMatrix(sa_size_t rowSize, SpSqMtxType typ);
+
+// Constructor de copy (avec partage de reference de NDataBlock) 
+SpecialSquareMatrix(SpecialSquareMatrix<T> const & a,  bool share=true);  
+
+// Allocation / changement de taille - Doit etre redefinie par les classes derivees
+virtual void SetSize(sa_size_t rowSize);
+
+//! Alias for SetSize() 
+inline void ReSize(sa_size_t rowSize) 
+{
+  return SetSize(rowSize);
+}
+
+//! Alias for SetSize() 
+inline void ReSizeRow(sa_size_t rowSize) 
+{
+  return SetSize(rowSize);
+}
+
+// Retourne l'objet sous forme d'une TMatrix<T> 
+virtual TMatrix<T> ConvertToStdMatrix() const;
+
+// Clone : duplique l'objet et ses donnees 
+virtual void Clone(SpecialSquareMatrix<T> const & a);
+
+// Share : recopie l'objet a avec partage des donnees des elements  
+virtual void Share(SpecialSquareMatrix<T> const & a);
+
+// Operation de Share() si objet temporaire, Clone() sinon
+virtual void CloneOrShare(SpecialSquareMatrix<T> const & a);
+
+//! Flags the associated NDataBlock as temporary if \b fgtmp==true
+inline void SetTemp(bool fgtmp=false) const  { mElems.SetTemp(fgtmp); } 
+
+//! Return the matrix type (Diagonal, Triangular ...) 
+inline SpSqMtxType MtxType() const { return mType; }
+//! Return number of rows
+inline  sa_size_t NRows() const {return (int_4)mNrows;}
+//! Return number of colums ( = NRows())
+inline  sa_size_t NCols() const {return (int_4)mNrows;}
+
+//! Return the total number of non zero elements 
+inline sa_size_t Size() const { return mElems.Size();}
+
+//! Return reference to datablock containg matrix elements NDataBlock
+inline NDataBlock<T>& DataBlock()   { return mElems; }
+//! Return reference to datablock containg matrix elements NDataBlock
+inline const NDataBlock<T>& DataBlock() const  { return mElems; }
+
+//! Return a reference to the associated DVList object 
+inline DVList& Info()
+  { if (mInfo==NULL)  mInfo = new DVList;  return (*mInfo); }
+
+// Pour mettre tous les elements a la valeur a 
+virtual SpecialSquareMatrix<T>& SetCst(T a);
+
+//! Alias for SetT(a) - Set all matrix elements to the value \b a
+inline SpecialSquareMatrix<T>& SetT(T a)
+  { return SetCst(a); }
+
+//  Egalite/Recopie element par element 
+virtual SpecialSquareMatrix<T>& Set(SpecialSquareMatrix<T> const & a);
+
+//  Remplissage avec une sequence de valeurs
+virtual SpecialSquareMatrix<T>& SetSeq(Sequence const & seq);
+
+// Ajout de la constante "b: a  tous les elements
+virtual SpecialSquareMatrix<T>& AddCst(T b);
+
+// Soustrait "b" a  tous les elements - fginv==true -> elem = b-elem
+virtual SpecialSquareMatrix<T>& SubCst(T b, bool fginv=false);
+
+// Multiplie "b" a tous les elements 
+virtual SpecialSquareMatrix<T>& MulCst(T b);
+
+// Divise tous les elements par "b". fginv==true elem = b / elem 
+virtual SpecialSquareMatrix<T>& DivCst(T b, bool fginv=false);
+
+// Addition element par element:  elem(l,c) = elem(l,c) + b.elem(l,c)
+virtual SpecialSquareMatrix<T>& AddElt(SpecialSquareMatrix<T> const& b);
+
+// Soustraction element par element : elem(l,c) = elem(l,c) - b.elem(l,c)
+virtual SpecialSquareMatrix<T>& SubElt(SpecialSquareMatrix<T> const& b);
+
+// Multiplication element par element : elem(l,c) = elem(l,c) * b.elem(l,c)
+virtual SpecialSquareMatrix<T>& MulElt(SpecialSquareMatrix<T> const& b);
+
+// Division element par element : elem(l,c) = elem(l,c) / b.elem(l,c)
+virtual SpecialSquareMatrix<T>& DivElt(SpecialSquareMatrix<T> const& b);
+
+//--- Operateurs = (T b) , = (SpecialSquareMatrix<T> b)
+//! operator = a , to set all elements to the value \b a
+inline SpecialSquareMatrix<T>& operator = (T a)
+  {  return SetCst(a);  }
+//! operator = SpecialSquareMatrix<T> a , element by element copy operator
+inline SpecialSquareMatrix<T>& operator = (SpecialSquareMatrix<T> const & a)
+  {  return Set(a); }
+//! operator = Sequence seq , 
+inline SpecialSquareMatrix<T>& operator = (Sequence const & seq)
+  {  return SetSeq(seq); }
+
+//--- Operateur += -= *= /= (T b)
+//! operator += b , Add a constant value \b b to all elements
+inline SpecialSquareMatrix<T>& operator += (T b)
+  { return AddCst(b); }
+//! operator -= b , subtract a constant value \b b from all elements
+inline SpecialSquareMatrix<T>& operator -= (T b)
+  { return SubCst(b); }
+//! operator *= b , multiply all elements by  a constant value \b b 
+inline SpecialSquareMatrix<T>& operator *= (T b)
+  { return MulCst(b); }
+//! operator /= b , divide all elements by  a constant value \b b 
+inline SpecialSquareMatrix<T>& operator /= (T b)
+  { return DivCst(b); }
+
+//! Element access operator (R/W): access to the element at position \b index - No bound checking
+inline T& operator[](sa_size_t index) 
+  { return  mElems(index); }
+//! Element access operator (RO): access to the element at position \b index - No bound checking
+inline T operator[](sa_size_t index) const
+  { return  mElems(index); }
+
+// Valeur min et max des elements (sauf tableaux complexes -> exception)
+virtual void MinMax(T& min, T& max) const ;
+
+// Impression / representation texte sur le flot os
+virtual ostream& Show(ostream& os) const;
+
+friend class FIO_SpecialSquareMatrix<T>;
+//..............
+protected: 
+SpSqMtxType mType;        //!< Type of the square matrix (diagonal, symmetric, triangular)
+sa_size_t mNrows;         //!< size of the square matrix
+NDataBlock<T> mElems;     //!< Data block
+DVList* mInfo;            //!< Associated DVList structure
+};
+
+//! print (ascii representation) operator
+template <class T>
+inline ostream& operator << (ostream& os, const SpecialSquareMatrix<T>& a)
+                            { a.Show(os);    return(os);    }
+
+////////////////////////////////////////////////////////////////
+// Surcharge d'operateurs A (+,-,*,/) (T) x
+
+/*! \ingroup TArray \fn operator+(const SpecialSquareMatrix<T>&,T)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix + constant */
+template <class T> inline SpecialSquareMatrix<T> operator + (const SpecialSquareMatrix<T>& a, T b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.AddCst(b); return result; }
+
+/*! \ingroup TArray \fn operator+(T,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = constant + SpecialSquareMatrix */
+template <class T> inline SpecialSquareMatrix<T> operator + (T b,const SpecialSquareMatrix<T>& a)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.AddCst(b); return result; }
+
+/*! \ingroup TArray \fn operator-(const SpecialSquareMatrix<T>&,T)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix - constant */
+template <class T> inline SpecialSquareMatrix<T> operator - (const SpecialSquareMatrix<T>& a, T b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.SubCst(b); return result; }
+
+/*! \ingroup TArray \fn operator-(T,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = constant - SpecialSquareMatrix */
+template <class T> inline SpecialSquareMatrix<T> operator - (T b,const SpecialSquareMatrix<T>& a)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.SubCst(b, true); return result; }
+
+/*! \ingroup TArray \fn operator*(const SpecialSquareMatrix<T>&,T)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix * constant */
+template <class T> inline SpecialSquareMatrix<T> operator * (const SpecialSquareMatrix<T>& a, T b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.MulCst(b); return result; }
+
+/*! \ingroup TArray \fn operator*(T,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = constant * SpecialSquareMatrix */
+template <class T> inline SpecialSquareMatrix<T> operator * (T b,const SpecialSquareMatrix<T>& a)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.MulCst(b); return result; }
+
+/*! \ingroup TArray \fn operator/(const SpecialSquareMatrix<T>&,T)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix / constant */
+template <class T> inline SpecialSquareMatrix<T> operator / (const SpecialSquareMatrix<T>& a, T b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.DivCst(b); return result; }
+
+/*! \ingroup TArray \fn operator/(T,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = constant / SpecialSquareMatrix  */
+template <class T> inline SpecialSquareMatrix<T> operator / (T b, const SpecialSquareMatrix<T>& a)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.DivCst(b, true); return result; }
+
+
+////////////////////////////////////////////////////////////////
+// Surcharge d'operateurs C = A (+,-,&&,/) B
+
+/*! \ingroup TArray \fn operator+(const SpecialSquareMatrix<T>&,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix + SpecialSquareMatrix (element by element addition) */
+template <class T>
+inline SpecialSquareMatrix<T> operator + (const SpecialSquareMatrix<T>& a,const SpecialSquareMatrix<T>& b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.AddElt(b); return result; }
+
+/*! \ingroup TArray \fn operator-(const SpecialSquareMatrix<T>&,const SpecialSquareMatrix<T>&)
+  \brief Operator SpecialSquareMatrix = SpecialSquareMatrix - SpecialSquareMatrix (element by element subtraction) */
+template <class T>
+inline SpecialSquareMatrix<T> operator - (const SpecialSquareMatrix<T>& a,const SpecialSquareMatrix<T>& b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.SubElt(b); return result; }
+
+/*! \ingroup TArray \fn operator && (const SpecialSquareMatrix<T>&,const SpecialSquareMatrix<T>&)
+  \brief Element by element multiplication of two arrays SpecialSquareMatrix = SpecialSquareMatrix * SpecialSquareMatrix */
+
+template <class T>
+inline SpecialSquareMatrix<T> operator && (const SpecialSquareMatrix<T>& a,const SpecialSquareMatrix<T>& b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.MulElt(b); return result; }
+
+/*! \ingroup TArray \fn operator / (const SpecialSquareMatrix<T>&,const SpecialSquareMatrix<T>&)
+  \brief Element by element division of two arrays SpecialSquareMatrix = SpecialSquareMatrix / SpecialSquareMatrix */
+template <class T>
+inline SpecialSquareMatrix<T> operator / (const SpecialSquareMatrix<T>& a,const SpecialSquareMatrix<T>& b)
+  { SpecialSquareMatrix<T> result; result.CloneOrShare(a); 
+    result.SetTemp(true);  result.DivElt(b); return result; }
+  
+}   // namespace SOPHYA
+
+#endif
Index: trunk/SophyaLib/TArray/spesqmtx_tsnl.h
===================================================================
--- trunk/SophyaLib/TArray/spesqmtx_tsnl.h	(revision 3809)
+++ trunk/SophyaLib/TArray/spesqmtx_tsnl.h	(revision 3809)
@@ -0,0 +1,28 @@
+#ifdef TSNMLUPG4
+/* This is a specific declaration file to cope with two level 
+   name look-up scheme , introduced by gcc >= 3.4 
+   THIS FILE SHOULD NOT NORMALLY BE INCLUDED IN USER PROGRAMS 
+*/
+
+using SOPHYA::SpecialSquareMatrix<T>::mType  ;
+using SOPHYA::SpecialSquareMatrix<T>::mNrows  ;
+using SOPHYA::SpecialSquareMatrix<T>::mElems  ;
+using SOPHYA::SpecialSquareMatrix<T>::mInfo  ;
+
+using SOPHYA::SpecialSquareMatrix<T>::SetSize  ;
+using SOPHYA::SpecialSquareMatrix<T>::ReSize  ;
+using SOPHYA::SpecialSquareMatrix<T>::ReSizeRow  ;
+
+using SOPHYA::SpecialSquareMatrix<T>::Info  ;
+
+using SOPHYA::SpecialSquareMatrix<T>::MtxType  ;
+using SOPHYA::SpecialSquareMatrix<T>::NRows  ;
+using SOPHYA::SpecialSquareMatrix<T>::NCols  ;
+using SOPHYA::SpecialSquareMatrix<T>::Size  ;
+using SOPHYA::SpecialSquareMatrix<T>::SetSeq  ;
+
+/*
+using SOPHYA::SpecialSquareMatrix<T> ;
+*/
+
+#endif  /* TSNMLUPG4 */
